from dnslib import *
from dnslib import server
import subprocess

class DNSServer:
    def __init__(self, whitelist_file_path):
        self.whitelist_file_path = whitelist_file_path

    def check_whitelist(self, domain):
        try:
            with open(self.whitelist_file_path, "r") as file:
                whitelist = [line.strip() for line in file]

            return any(domain.lower() == item.lower() + '.' for item in whitelist)
        except Exception as e:
            print(f"Failed to read whitelist file: {str(e)}")
            return False

    def resolve(self, request, handler):
        domain = str(request.q.qname)
        response = request.reply()

        print(self.check_whitelist(domain))
  
        if self.check_whitelist(domain):
            print('whitelist domain:' + domain)
            try:
                upstream_response = DNSRecord.parse(DNSRecord.question(domain).send("10.254.0.5", timeout=2))
                for record in upstream_response.rr:
                    print(record)
                    response.add_answer(record)
                    if isinstance(record.rdata, dns.A):
                        ip_address = str(record.rdata)
                        subprocess.run(["ip", "route", "add", f"{ip_address}/32", "via", "10.254.0.5"])
            except Exception as e:
                print(f"Failed to resolve {domain} from upstream server: {str(e)}")

        else:
            print('not whitelist domain:' + domain)
            try:
                upstream_response = DNSRecord.parse(DNSRecord.question(domain).send("180.76.76.76", timeout=2))
                for record in upstream_response.rr:
                    response.add_answer(record)
            except Exception as e:
                print(f"Failed to resolve {domain} from upstream server: {str(e)}")
        print(response)
        return response

dns_server = DNSServer("whitelist.txt")
resolver = server.DNSServer(dns_server, port=53, address="")
resolver.start()